#include <iostream.h>
#include <stdlib.h>
const float pi = 3.14159;

class box {
   public: 
      box() {};
      box(float h, float w, float l){
         height =h; width = w; length = l;
         }
      float volume () {return height * width * length; }
   protected:
      float read_height () {return height;}
      float read_width ()  {return width;}
      float read_length () {return length;}
   private: float height, width, length;
   };
class cylinder {
   public: 
      cylinder () {};
      cylinder (float r, float l){
         radius = r; length = l;
         }
      float volume () { return pi * radius * radius * length; }
   protected:
      float read_radius () {return radius;}
      float read_length () {return length;}
   private: float radius, length;
   };
class railroad_car {
   public: railroad_car () {} 
      virtual char* short_name () {return "rrc";}
      virtual float capacity ()   { return 0.0;}
   };
class box_car : public railroad_car, public box {
   public: box_car () : box (10.5, 9.5, 40.0) {} 
      virtual char* short_name () {return "box";}
      virtual float capacity() {return volume();}
   };
class tank_car : public railroad_car, public cylinder {
   public: tank_car () : cylinder (3.5, 40.0) {} 
      virtual char* short_name () {return "tnk";}
      virtual float capacity() {return volume();}
   };
class engine :   public railroad_car {
   public: engine () {} 
      virtual char* short_name () {return "eng";}
   };
class caboose:   public railroad_car {
   public: caboose () {} 
      virtual char* short_name () {return "cab";}
   };

railroad_car *train[100];
enum { eng_code, box_code, tnk_code, cab_code};

// Overload <<:
ostream& operator<< (ostream& output_stream, railroad_car& r) {
   output_stream << "[" << r.short_name () << "]";
   return output_stream;
   }

main () { 
int n, car_count, type_code;
for (car_count = 0; cin >> type_code; ++car_count) {
   if (car_count > 100) { 
      cerr << "Array overflow in train[n]!" << endl;
      exit (0);
      }
   switch (type_code) {
      case eng_code: train[car_count] = new engine;  break;
      case box_code: train[car_count] = new box_car; break;
      case tnk_code: train[car_count] = new tank_car;break;
      case cab_code: train[car_count] = new caboose; break;
      default: cerr << "Car code "<< type_code 
		    << " is unknown!" << endl; 
	       exit (0); 
      }
   }
//Display icons:
cout << *train[0];
for (n = 1; n < car_count; ++n) {
   cout << "-" << *train[n];
   }
cout << endl;
}

